
/*************************************
 *   CE DONT L'INTERFACE A BESOIN
 ************************************/

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include "jeu.h"
#include "interface_extern.h"
#include "interface_needs.h"

#undef M_PI
#define M_PI 3.14159265358979323846

#define INPUT_TIMESTAMP 30

#if __USE_ISOC99
#define SIN(a) sinf(a)
#define COS(a) cosf(a)
#else
#define SIN(a) sin(a)
#define COS(a) cos(a)
#endif

#define m 18
#define n 12

typedef struct vaisseau_bidon{
 int x;
 int y;
 int etat;
 int nb_vie;
 int vitesse;
 int direction;
 char nom[256];
} vaisseau;

vaisseau vaisseau1;

typedef struct {
	int x;
	int y;
	int energie;
	int direction;
}monstre;

monstre  monstre1;

typedef struct {
 int x;
 int y;
 int etat;
 int direction;
}tir;
tir tir1,tir2;

typedef struct {
char nom[20];
int score;
int numero;
}joueur;

joueur joueur1;

int nb_pastille;//nb de pastilles ds le jeu actuellement
int lev[m][n];//tableau des cases sur le niveau

/* La fonction appelee regulierement */
void Timer_fini (void) {
}

void tuer(void){
if(monstre1.energie-1==0){
	monstre1.energie=0;
	monstre1.x=-50;
	monstre1.y=-50;
	Preparer_Monstre(0,0,0,monstre1.x,monstre1.y);
}else{
	monstre1.energie-=1;
	Preparer_Monstre(0,0,0,monstre1.x,monstre1.y);
}

}

void PreparerNiveau(void){
int i=0,j=0,nextlarg=0,nexthaut=0;
nb_pastille=0;
for(i=0;i<=m;i++){
	for(j=0;j<n;j++){
		switch(lev[i][j]){
			case '9' :
			//printf("9");
			Preparer_Mur(0,1,nextlarg,nexthaut);
			nextlarg+=Largeur_Monstre();
			break;

			case '0' :
			//printf("0");
			nextlarg+=Largeur_Monstre();
			break;

			case '1' :
			//printf("1");
		Preparer_Pastille(0,0,nextlarg+Largeur_Pastille(),nexthaut+Largeur_Pastille());
			nextlarg+=Largeur_Monstre();
			nb_pastille++;
			break;

			default :
			//printf("default");
			break;
		}

	}
	nexthaut+=Hauteur_Monstre();
	nextlarg=0;//a la fin de la ligne on revien a 0
}

Afficher_Ecran(0);

}//FIN preparer niveau

void AfficherNiveau(void){
FILE * niveau;

int caseniveau=0,i=0,j=0;

if((niveau=fopen("./Lev/lev1.txt","r"))!=NULL){//si on arrive a ouvrir le fichier
	caseniveau=fgetc(niveau);
	while(caseniveau!=EOF){
		//printf("%c", caseniveau);
		//printf("[i %d]",i);
		//printf("[j %d]\n",j);
		lev[i][j]=caseniveau;
		caseniveau=fgetc(niveau);
		j++;
			if(caseniveau=='\n'){
				i++;
				j=0;
				caseniveau=fgetc(niveau);
			}
	}
}else{
	printf("Fichier non trouve");
}

fclose(niveau);
PreparerNiveau();
}//fin de afficher niveau



/* La fonction associee au bouton Jouer */
void Jouer (void) {

	Preparer_Fond(0);
	AfficherNiveau();
	vaisseau1.x=64;
	vaisseau1.y=32;
	vaisseau1.vitesse=4;
	vaisseau1.direction=0;
	monstre1.x=32;
	monstre1.y=32;
	monstre1.direction=1;
	Preparer_Monstre(0,2,monstre1.direction,monstre1.x,monstre1.y);
	joueur1.score = 0;
	Preparer_Vaisseau(0,0,vaisseau1.direction,vaisseau1.x,vaisseau1.y);
	Brancher_Timer(10);//execute le contenu de timerfini puis touches enfonces
	Afficher_Ecran (0);
}

/* La fonction associee au bouton Quitter */
void Quitter  (void) {
}

void Touches_Enfoncees(char touches[NB_TOUCHES]){
int j1D=0,j1G=0,j1H=0,j1B=0,j1T=0;

if(touches[0]==1){
j1D=1;
}
if(touches[1]==1){
j1G=1;
}
if(touches[2]==1){
j1H=1;
}
if(touches[3]==1){
j1B=1;
}
if(touches[4]==1){
j1T=1;
}


Preparer_Fond(0);
PreparerNiveau();
Preparer_Vaisseau(0,0,vaisseau1.direction,vaisseau1.x,vaisseau1.y);
Preparer_Monstre(0,2,monstre1.direction,monstre1.x,monstre1.y);

if(vaisseau1.x>Largeur_Jeu()-Largeur_Vaisseau()){
	vaisseau1.x=Largeur_Jeu()-Largeur_Vaisseau();
}

if(vaisseau1.x<0){
	vaisseau1.x=0;
}

if(vaisseau1.y<0){
	vaisseau1.y=0;
}

if(vaisseau1.y>Hauteur_Jeu()-Hauteur_Vaisseau()){
	vaisseau1.y=Hauteur_Jeu()-Hauteur_Vaisseau();
}

if(j1G==1){
	if((lev[(vaisseau1.y+3)/32][(vaisseau1.x-3)/32]=='9')||(lev[(vaisseau1.y+32-3)/32][(vaisseau1.x-3)/32]=='9')){
	}
	else{
		vaisseau1.x-=j1G*vaisseau1.vitesse;
		vaisseau1.direction=3;

	}
}

if(j1D==1){
	if((lev[(vaisseau1.y+3)/32][(vaisseau1.x+32+3)/32]=='9')||(lev[(vaisseau1.y+32-3)/32][(vaisseau1.x+32+3)/32]=='9')){
	}
	else{
		vaisseau1.x+=j1D*vaisseau1.vitesse;
		vaisseau1.direction=1;
	}
}

if(j1B==1){
	if((lev[(vaisseau1.y+32+3)/32][(vaisseau1.x+3)/32]=='9')||(lev[(vaisseau1.y+32+3)/32][(vaisseau1.x+32-3)/32]=='9')){
	}
	else{
		vaisseau1.y+=j1B*vaisseau1.vitesse;
		vaisseau1.direction=2;
	}
}

if(j1H==1){
	if((lev[(vaisseau1.y-3)/32][(vaisseau1.x+3)/32]=='9')||(lev[(vaisseau1.y-3)/32][(vaisseau1.x+32-3)/32])=='9'){
	}
	else{
		vaisseau1.y-=j1H*vaisseau1.vitesse;
		vaisseau1.direction=0;

	}
}
//Recuperer les pastilles
if(lev[(vaisseau1.y+Largeur_Pastille())/32][(vaisseau1.x+Largeur_Pastille())/32]=='1'){
		nb_pastille--;
		if(nb_pastille==0){
		printf("Gagn !\n");
		}
		lev[(vaisseau1.y+Largeur_Pastille())/32][(vaisseau1.x+Largeur_Pastille())/32]='0';
		joueur1.score++;
		}

Afficher_Ecran(0);

//Tir avec directions

if(tir1.etat==0){
	if(j1T==1){
			tir1.x=vaisseau1.x+16;
			tir1.y=vaisseau1.y+16;
			Preparer_Tir_Vaisseau(0,0,tir1.x,tir1.y);
			tir1.direction=vaisseau1.direction;
			tir1.etat=1;
	}
}else{
	//droite
	if(tir1.direction==1){
		tir1.x+=8;
		Preparer_Tir_Vaisseau(0,0,tir1.x,tir1.y);
if((lev[(tir1.y)/32][(tir1.x)/32]=='9')||(lev[(tir1.y)/32][(tir1.x)/32]=='9')){tir1.etat=0;}
	}
	//haut
	if(tir1.direction==0){
		tir1.y-=8;
		Preparer_Tir_Vaisseau(0,0,tir1.x,tir1.y);
		//if(tir1.y<=0){tir1.etat=0;}
if((lev[(tir1.y)/32][(tir1.x)/32]=='9')||(lev[(tir1.y)/32][(tir1.x)/32])=='9'){tir1.etat=0;}
	}
	//bas
	if(tir1.direction==2){
		tir1.y+=8;
		Preparer_Tir_Vaisseau(0,0,tir1.x,tir1.y);
if((lev[(tir1.y)/32][(tir1.x)/32]=='9')||(lev[(tir1.y+3)/32][(tir1.x)/32]=='9')){
			tir1.etat=0;
		}
	}
	//gauche
	if(tir1.direction==3){
		tir1.x-=8;
		Preparer_Tir_Vaisseau(0,0,tir1.x,tir1.y);
if((lev[(tir1.y)/32][(tir1.x)/32]=='9')||(lev[(tir1.y)/32][(tir1.x)/32]=='9')){tir1.etat=0;}
	}
}


//Preparer_Monstre(0,0,0,monstre1.x,monstre1.y);
Afficher_Score(joueur1.score,0);
Afficher_Ecran(0);

}// FIN touche enfoncees


/* ************* Les deux fonctions a appeler dans le main ******/

void Init_Jeu (int nb, int ne, int invulnerable) {
 // time_t t_loc;
  //struct tm *tmp;

  fprintf(stdout,"Hi!\n");
 // time(&t_loc);
  //tmp= localtime(&t_loc);
 // srand(getpid()*(tmp->tm_sec));
}

void Fin_Jeu (void) {
  fprintf(stdout,"Bye!\n");
}

