
/*************************************
 *   CE DONT L'INTERFACE A BESOIN
 ************************************/

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include "jeu.h"
#include "interface_extern.h"
#include "interface_needs.h"

#undef M_PI
#define M_PI 3.14159265358979323846

#define INPUT_TIMESTAMP 30

#if __USE_ISOC99
#define SIN(a) sinf(a)
#define COS(a) cosf(a)
#else
#define SIN(a) sin(a)
#define COS(a) cos(a)
#endif

#define m 18
#define n 12

typedef struct vaisseau_bidon{
 int x;
 int y;
 int etat;
 int nb_vie;
 int vitesse;
 int direction;
 char nom[256];
} vaisseau;

vaisseau vaisseau1;

typedef struct trajectoire_bidon{
int trajectoire;
int distance;
int possibilite;
}trajectoire;

trajectoire POSS1[4],POSS2[4];

typedef struct {
	int x;
	int y;
	int energie;
	int etat;
}monstre;

monstre  monstre1,monstre2,monstre3,monstre4;

typedef struct {
 int x;
 int y;
 int etat;
 int direction;
}tir;
tir tir1,tir2;

typedef struct {
char nom[20];
int score;
int numero;
}joueur;

joueur joueur1;

int position1,position2,choix1,choix2,choix3,choix4;



int nb_pastille;//nb de pastilles ds le jeu actuellement
int lev[m][n];//tableau des cases sur le niveau
int niveau_actuel;
int changer_niveau;
int compte_pause;

/* La fonction appelee regulierement */
void Timer_fini (void) {


}
int distance(int xv,int yv,int xe,int ye)
//cette fonction calcule la distance entre le vaisseau et le monstre.
{
	int abscisse,ordonnee,distance;
	abscisse=pow((xe-xv),(2));
	ordonnee=pow((ye-yv),(2));
	distance=sqrt(abscisse+ordonnee);
	return distance;
}


int pluspetitedistance(int xe,int ye)
//cette fonction renvoit le numro de la trajectoire qui va rapprocher le plus le monstre du vaisseau.
{
	int p1,p2,p3,p4,min,rep=0;
	p1=distance(vaisseau1.x,vaisseau1.y,xe+3,ye);
	p2=distance(vaisseau1.x,vaisseau1.y,xe-3,ye);
	p3=distance(vaisseau1.x,vaisseau1.y,xe,ye+3);
	p4=distance(vaisseau1.x,vaisseau1.y,xe,ye-3);
	min=p1;
	if(min>p2)
	{min=p2;}
	if(min>p3)
	{min=p3;}
	if(min>p4)
	{min=p4;}
	if(min==p1){rep=1;}
	if(min==p2){rep=2;}
	if(min==p3){rep=3;}
	if(min==p4){rep=4;}
	return rep;
}


int cheminapp(trajectoire *tableau,int xe,int ye)
//cette fonctionne donne par ordre croissante la trajectoire la plus courte pour aller au vaisseau.
{
	trajectoire temp;
	int i,j,z;
	tableau[0].distance=distance(vaisseau1.x,vaisseau1.y,xe+3,ye);
	tableau[0].trajectoire=0;
	printf("mur a droite %c\n",lev[(ye+16+32)/32][(xe+3+32)/32]);
	if((lev[(ye+3)/32][(xe+32+3)/32]=='9')||(lev[(ye+32-3)/32][(xe+32+3)/32]=='9'))
	{tableau[0].possibilite=0;}else{tableau[0].possibilite=1;}

	tableau[1].distance=distance(vaisseau1.x,vaisseau1.y,xe-3,ye);
	tableau[1].trajectoire=1;
	printf("mur a gauche %c\n",lev[(ye+3)/32][(xe-3)/32]);
	if((lev[(ye+3)/32][(xe-3)/32]=='9')||(lev[(ye+32-3)/32][(xe-3)/32]=='9'))
	{tableau[1].possibilite=0;}else{tableau[1].possibilite=1;}

	tableau[2].distance=distance(vaisseau1.x,vaisseau1.y,xe,ye+3);
	tableau[2].trajectoire=2;
	printf("mur en bas %c\n",lev[(ye+3)/32][(xe+16)/32]);
	if((lev[(ye+32+3)/32][(xe+3)/32]=='9')||(lev[(ye+32+3)/32][(xe+32-3)/32]=='9'))
	{tableau[2].possibilite=0;}else{tableau[2].possibilite=1;}

	tableau[3].distance=distance(vaisseau1.x,vaisseau1.y,xe,ye-3);
	tableau[3].trajectoire=3;
	printf("mur en haut %c\n",lev[(ye-3)/32][(xe+16)/32]);
	if((lev[(ye-3)/32][(xe+3)/32]=='9')||(lev[(ye-3)/32][(xe+32-3)/32]=='9'))
	{tableau[3].possibilite=0;}else{tableau[3].possibilite=1;}

	for(j=0;j<4;j++)
	{
	z=4-j;
	for(i=0;i<z;i++)
	{
	if(tableau[i].distance>tableau[i+1].distance)
	{
		temp.distance=tableau[i+1].distance;
		temp.trajectoire=tableau[i+1].trajectoire;
		temp.possibilite=tableau[i+1].possibilite;
		tableau[i+1].distance=tableau[i].distance;
		tableau[i+1].trajectoire=tableau[i].trajectoire;
		tableau[i+1].possibilite=tableau[i].possibilite;
		tableau[i].distance=temp.distance;
		tableau[i].trajectoire=temp.trajectoire;
		tableau[i].possibilite=temp.possibilite;
	}
	}

	}
	i=0;
	while(tableau[i].possibilite==0)
	{i++;
	}


	/*printf("%d %d %d \n",POSS[0].trajectoire,POSS[0].distance,POSS[0].possibilite);
	printf("%d %d %d \n",POSS[1].trajectoire,POSS[1].distance,POSS[1].possibilite);
	printf("%d %d %d \n",POSS[2].trajectoire,POSS[2].distance,POSS[2].possibilite);
	printf("%d %d %d \n",POSS[3].trajectoire,POSS[3].distance,POSS[3].possibilite);*/
	return tableau[i].trajectoire;
}


/*

void init_monstre(monstre *munster){
munster->energie=1;
Preparer_Monstre(0,0,1,munster->x,munster->y);
}
*/
void init_monstre(monstre *munster){
printf("Initialisation du monstre \n");
munster->energie=2;
munster->etat=1;
Preparer_Monstre(0,0,1,munster->x,munster->y);
}

/*
void tuer(monstre munster){
if(munster.energie==0){
	//monstre1.energie=0;
	//monstre1.x=-50;
	//monstre1.y=-50;
	Preparer_Monstre(0,0,0,munster.x,munster.y);
}else{
	munster.energie-=1;
	Preparer_Monstre(0,0,0,munster.x,munster.y);
}

}
*/
void tuer(monstre*munster){

//printf("etat %d\n",munster->etat);
//printf("energie  %d\n",munster->energie);

if(munster->energie==0){
	//monstre1.energie=0;
	munster->etat =0;
	munster->x=-100;
	munster->y=-100;
	//printf("energie %d\n",monstre1.energie);
	Preparer_Monstre(0,0,0,-20,-20);
}else{
	munster->energie=munster->energie-1;
	//printf(" TEST %d\n",munster->energie);
	Preparer_Monstre(0,0,0,munster->x,munster->y);
	//printf("energie %d\n",munster.energie);
}

}

void PreparerNiveau(void){
int i=0,j=0,nextlarg=0,nexthaut=0;
nb_pastille=0;
for(i=0;i<=m;i++){
	for(j=0;j<n;j++){
		switch(lev[i][j]){
			case '9' :
			//printf("9");
			Preparer_Mur(0,1,nextlarg,nexthaut);
			nextlarg+=Largeur_Monstre();
			break;

			case '5' :
			//printf("8");
			Preparer_Mur(0,0,nextlarg,nexthaut);
			nextlarg+=Largeur_Monstre();
			break;
			
			case '0' :
			//printf("0");
			nextlarg+=Largeur_Monstre();//un espace
			break;

			case '1' :
			//printf("1");
		Preparer_Pastille(0,0,nextlarg+Largeur_Pastille(),nexthaut+Largeur_Pastille());
			nextlarg+=Largeur_Monstre();
			nb_pastille++;
			break;

			default :
			//nextlarg+=Largeur_Monstre();//un espace
			break;
		}

	}
	nexthaut+=Hauteur_Monstre();
	nextlarg=0;//a la fin de la ligne on revien a 0
}

Afficher_Ecran(0);

}//FIN preparer niveau



void AfficherNiveau(void){
FILE * niveau;

int caseniveau=0,i=0,j=0;
char fichier[20];


//printf("test\n");
switch(niveau_actuel){
	case 1:
	strcpy(fichier,"./Lev/lev1.txt");
	printf("niveau %d",niveau_actuel);
	break;
	case 2:
	strcpy(fichier,"./Lev/lev2.txt");
	printf("niveau %d",niveau_actuel);
	break;
	default :
	strcpy(fichier,"./Lev/lev1.txt");
	break;
}


if((niveau=fopen(fichier,"r"))!=NULL){//si on arrive a ouvrir le fichier
	caseniveau=fgetc(niveau);
	while(caseniveau!=EOF){
		//printf("%c", caseniveau);
		//printf("[i %d]",i);
		//printf("[j %d]\n",j);
		lev[i][j]=caseniveau;
		caseniveau=fgetc(niveau);
		j++;
			if(caseniveau=='\n'){
				i++;
				j=0;
				caseniveau=fgetc(niveau);
			}
	}
}else{
	printf("Fichier %s non trouve\n",fichier);
}

fclose(niveau);
PreparerNiveau();
}//fin de afficher niveau





/* La fonction associee au bouton Jouer */
void Jouer (void) {
	niveau_actuel=1;
	Preparer_Fond(0,0);
	AfficherNiveau();
	vaisseau1.x=64;
	vaisseau1.y=32;
	vaisseau1.vitesse=4;
	vaisseau1.direction=0;
	monstre1.x=300;
	monstre1.y=32;
	monstre2.x=32;
	monstre2.y=512;
	monstre3.x=32;
	monstre3.y=32;
	monstre4.x=128;
	monstre4.y=256;
	init_monstre(&monstre1);
	init_monstre(&monstre2);
	joueur1.score = 0;
	changer_niveau=0;
	compte_pause=0;

	Preparer_Vaisseau(0,0,vaisseau1.direction,vaisseau1.x,vaisseau1.y);
	Brancher_Timer(20);//execute le contenu de timerfini puis touches enfonces
	Afficher_Ecran (0);
}

/* La fonction associee au bouton Quitter */
void Quitter  (void) {
}

void deplacement_vaisseau(int j1D,int j1G,int j1H,int j1B){

if(j1G==1){
	if((lev[(vaisseau1.y+2)/Hauteur_Vaisseau()][(vaisseau1.x-2)/Largeur_Vaisseau()]=='9')||(lev[(vaisseau1.y+Hauteur_Vaisseau()-2)/Hauteur_Vaisseau()][(vaisseau1.x-2)/Largeur_Vaisseau()]=='9')){
	}
	else{
		vaisseau1.x-=j1G*vaisseau1.vitesse;
		vaisseau1.direction=3;

	}
}

if(j1D==1){
	if((lev[(vaisseau1.y+2)/Hauteur_Vaisseau()][(vaisseau1.x+Largeur_Vaisseau()+2)/Largeur_Vaisseau()]=='9')||(lev[(vaisseau1.y+Hauteur_Vaisseau()-2)/Hauteur_Vaisseau()][(vaisseau1.x+Largeur_Vaisseau()+2)/Largeur_Vaisseau()]=='9')){
	}
	else{
		vaisseau1.x+=j1D*vaisseau1.vitesse;
		vaisseau1.direction=1;
	}
}

if(j1B==1){
	if((lev[(vaisseau1.y+Hauteur_Vaisseau()+2)/Hauteur_Vaisseau()][(vaisseau1.x+2)/Largeur_Vaisseau()]=='9')||(lev[(vaisseau1.y+Hauteur_Vaisseau()+2)/Hauteur_Vaisseau()][(vaisseau1.x+Largeur_Vaisseau()-2)/Largeur_Vaisseau()]=='9')){
	}
	else{
		vaisseau1.y+=j1B*vaisseau1.vitesse;
		vaisseau1.direction=2;
	}
}

if(j1H==1){
	if((lev[(vaisseau1.y-2)/Hauteur_Vaisseau()][(vaisseau1.x+2)/Largeur_Vaisseau()]=='9')||(lev[(vaisseau1.y-2)/32][(vaisseau1.x+Largeur_Vaisseau()-2)/Largeur_Vaisseau()])=='9'){
	}
	else{
		vaisseau1.y-=j1H*vaisseau1.vitesse;
		vaisseau1.direction=0;

	}
}


}

void deplacer_tir(void){

//droite
	if(tir1.direction==1){
		tir1.x+=8;
		Preparer_Tir_Vaisseau(0,0,tir1.x,tir1.y);
if((lev[(tir1.y)/Largeur_Case][(tir1.x)/Largeur_Case]=='9')||(lev[(tir1.y)/Largeur_Case][(tir1.x)/Largeur_Case]=='9')){tir1.etat=0;}
	}
	
	//haut
	if(tir1.direction==0){
		tir1.y-=8;
		Preparer_Tir_Vaisseau(0,0,tir1.x,tir1.y);
		//if(tir1.y<=0){tir1.etat=0;}
if((lev[(tir1.y)/Largeur_Case][(tir1.x)/Largeur_Case]=='9')||(lev[(tir1.y)/Largeur_Case][(tir1.x)/Largeur_Case])=='9'){tir1.etat=0;}
	}
	
	//bas
	if(tir1.direction==2){
		tir1.y+=8;
		Preparer_Tir_Vaisseau(0,0,tir1.x,tir1.y);
if((lev[(tir1.y)/Largeur_Case][(tir1.x)/Largeur_Case]=='9')||(lev[(tir1.y+3)/Largeur_Case][(tir1.x)/Largeur_Case]=='9')){
			tir1.etat=0;
		}
	}
	//gauche
	if(tir1.direction==3){
		tir1.x-=8;
		Preparer_Tir_Vaisseau(0,0,tir1.x,tir1.y);
if((lev[(tir1.y)/Largeur_Case][(tir1.x)/Largeur_Case]=='9')||(lev[(tir1.y)/Largeur_Case][(tir1.x)/Largeur_Case]=='9')){tir1.etat=0;}

}


}

void coll_monstre(monstre* munster){

if((tir1.x>munster->x)&&(tir1.x<munster->x+Largeur_Monstre())){
	if((tir1.y>munster->y)&&(tir1.y<munster->y+Largeur_Monstre())){
		tir1.etat=0;
		tuer(munster);
		//printf("tuer\n");
		}
	}
}

void Touches_Enfoncees(char touches[NB_TOUCHES]){
int j1D=0,j1G=0,j1H=0,j1B=0,j1T=0;


if (changer_niveau==1)
  {
    // Changer le papier peint pour indiquer changement niveau;
    Preparer_Fond(0,1);
    Afficher_Score(joueur1.score,0);
    Afficher_Ecran(0);


    // Laisser ce papier peint pendant x secondes
      compte_pause++;
      //niveau_actuel+=1;
      //printf("niveau actuel%d\n",niveau_actuel);
      //AfficherNiveau();
      if (compte_pause >= 100)
    	{
    	//Charger le nouveau niveau


    	// recommencer normalement.
    	changer_niveau=0;
	compte_pause=0;
	init_monstre(&monstre1);
	init_monstre(&monstre2);
	//printf("%d",niveau_actuel);
	niveau_actuel+=1;
	Afficher_Niveau(niveau_actuel);
	printf("niveau actuel %d\n",niveau_actuel);
	AfficherNiveau();
	}

  }
else
{
if(touches[0]==1){
j1D=1;
}
if(touches[1]==1){
j1G=1;
}
if(touches[2]==1){
j1H=1;
}
if(touches[3]==1){
j1B=1;
}
if(touches[4]==1){
j1T=1;
}

deplacement_vaisseau(j1D,j1G,j1H,j1B);

coll_monstre(&monstre1);
coll_monstre(&monstre2);

Preparer_Fond(0,0);
PreparerNiveau();
Preparer_Vaisseau(0,0,vaisseau1.direction,vaisseau1.x,vaisseau1.y);


//Recuperer les pastilles
if(lev[(vaisseau1.y+Largeur_Pastille())/Hauteur_Vaisseau()][(vaisseau1.x+Largeur_Pastille())/Largeur_Vaisseau()]=='1'){
		nb_pastille--;
		if(nb_pastille==0){
			changer_niveau=1;
		}
		lev[(vaisseau1.y+Largeur_Pastille())/Hauteur_Vaisseau()][(vaisseau1.x+Largeur_Pastille())/Largeur_Vaisseau()]='0';
		joueur1.score++;
		}

Afficher_Ecran(0);


//Tir avec directions
if(tir1.etat==0){
if(j1T==1){

			tir1.x=vaisseau1.x+(Largeur_Vaisseau()/2)-(Largeur_Pastille()/2);
			tir1.y=vaisseau1.y+(Hauteur_Vaisseau()/2)-(Hauteur_Pastille()/2);
			Preparer_Tir_Vaisseau(0,0,tir1.x,tir1.y);
			tir1.direction=vaisseau1.direction;
			tir1.etat=1;
}
}else{
	deplacer_tir();
}

//test de collision des tirs




choix1=pluspetitedistance(monstre1.x,monstre1.y);

	if((
	((vaisseau1.y>monstre1.y)&&(vaisseau1.direction!=0))
	||
	((vaisseau1.y<monstre1.y)&&(vaisseau1.direction!=2))
	)
	&&
	(
	((vaisseau1.x<monstre1.x)&&(vaisseau1.direction!=1))
	||
	((vaisseau1.x>monstre1.x)&&(vaisseau1.direction!=3))
	))
	{
	if(choix1==1)
	{
	monstre1.x=monstre1.x+(niveau_actuel+2)/3;
	//position1=1;
	}
	if(choix1==2)
	{
	monstre1.x=monstre1.x-(niveau_actuel+2)/3;
	//position1=3;
	}
	if(choix1==3)
	{
	monstre1.y=monstre1.y+(niveau_actuel+2)/3;
	//position1=2;
	}
	if(choix1==4)
	{
	monstre1.y=monstre1.y-(niveau_actuel+2)/3;
	//position1=0;
	}

	}
	choix2=pluspetitedistance(monstre2.x,monstre2.y);//renvoie le che

	if((
	((vaisseau1.y>monstre2.y)&&(vaisseau1.direction!=0))
	||
	((vaisseau1.y<monstre2.y)&&(vaisseau1.direction!=2))
	)
	&&
	((
	((vaisseau1.x<monstre2.x)&&(vaisseau1.direction!=1))
	||
	((vaisseau1.x>monstre2.x)&&(vaisseau1.direction!=3))
	))
	)
	{

	if((pow((monstre1.x-monstre2.x),2)>169)&&(pow((monstre1.y-monstre2.y),2)>169))
	{
	if(choix2==1)
	{
	monstre2.x=monstre2.x+(niveau_actuel+2)/3;
	//position2=1;
	}
	if(choix2==2)
	{
	monstre2.x=monstre2.x-(niveau_actuel+2)/3;
	//position2=3;
	}
	//}
	if(choix2==3)
	{
	monstre2.y=monstre2.y+(niveau_actuel+2)/3;
	//position2=2;
	}
	if(choix2==4)
	{
	monstre2.y=monstre2.y-(niveau_actuel+2)/3;
	//position2=0;
	}
	}
	}


if(monstre1.etat == 1){
Preparer_Monstre(0,0,0,monstre1.x,monstre1.y);
}
if(monstre2.etat == 1){
Preparer_Monstre(0,0,0,monstre2.x,monstre2.y);
}
if(monstre3.etat == 1){
Preparer_Monstre(0,1,0,monstre3.x,monstre3.y);
}

Afficher_Score(joueur1.score,0);

}//fin de If changer niveau==1


if(((monstre3.x%32)==0)&&((monstre3.y)%32)==0){
choix3=cheminapp(POSS1,monstre3.x,monstre3.y);
printf("choix = %d\n",choix3);
}
if(choix3==0)
{monstre3.x=monstre3.x+2;}
if(choix3==1)
{monstre3.x=monstre3.x-2;}
if(choix3==2)
{monstre3.y=monstre3.y+2;}
if(choix3==3)
{monstre3.y=monstre3.y-2;}

Preparer_Monstre(0,1,0,monstre3.x,monstre3.y);

if(((monstre4.x%32)==0)&&((monstre4.y)%32)==0){
choix4=cheminapp(POSS2,monstre4.x,monstre4.y);
printf("choix = %d\n",choix4);
}
if(choix4==0)
{monstre4.x=monstre4.x+2;}
if(choix4==1)
{monstre4.x=monstre4.x-2;}
if(choix4==2)
{monstre4.y=monstre4.y+2;}
if(choix4==3)
{monstre4.y=monstre4.y-2;}
Preparer_Monstre(0,1,0,monstre4.x,monstre4.y);

Afficher_Ecran(0);
//printf("%d  %d  %d\n",monstre3.x,monstre3.y,rythme);*/
}// FIN touche enfoncees


/* ************* Les deux fonctions a appeler dans le main ******/

void Init_Jeu (int nb, int ne, int invulnerable) {
 // time_t t_loc;
  //struct tm *tmp;

  fprintf(stdout,"Hi!\n");
 // time(&t_loc);
  //tmp= localtime(&t_loc);
 // srand(getpid()*(tmp->tm_sec));
}

void Fin_Jeu (void) {
  fprintf(stdout,"Bye!\n");
}

