
/*************************************
 *   CE DONT L'INTERFACE A BESOIN
 ************************************/

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <time.h>
#include "jeu.h"
#include "interface_extern.h"
#include "interface_needs.h"

#undef M_PI
#define M_PI 3.14159265358979323846

#define INPUT_TIMESTAMP 30

#if __USE_ISOC99
#define SIN(a) sinf(a)
#define COS(a) cosf(a)
#else
#define SIN(a) sin(a)
#define COS(a) cos(a)
#endif

#define m 18
#define n 12


typedef struct vaisseau_bidon{
 int x;
 int y;
 int etat;
 int energie;
 int vitesse;
 int direction;
 char nom[256];
} vaisseau;

vaisseau vaisseau1;

typedef struct trajectoire_bidon{
int trajectoire;
int distance;
int possibilite;
}targ;

ship untruc; 
//trajectoire POSS1[4];

typedef struct {
	int x;
	int y;
	int energie;
	int etat;
	int type;
	int direction;
	int choix;
	int temporaire_x;
	int temporaire_y;
	targ POSS[4];
}monstre;

monstre  monstre1,monstre2,monstre3,monstre4,monstre6;

monstre *monstre5;

typedef struct {
 int x;
 int y;
 int etat;
 int direction;
}tir;
tir tir1,tir2;

typedef struct pastille_bidon{
int x;
int y;
int choix;
targ POSS[4];
}pastille;

pastille pastille1;


typedef struct {
char nom[20];
int score;
int numero;
int nb_vie;
}joueur;

joueur joueur1;

int position1,position2,rythme=0;


int nb_pastille;//nb de pastilles ds le jeu actuellement
int lev[m][n];//tableau des cases sur le niveau
int niveau_actuel;
int changement_niveau;
int compte_pause;


void init_pastille_energie(void){
pastille1.x=256;
pastille1.y=32;
}


/* La fonction appelee regulierement */
void Timer_fini (void) {
rythme++;
if(rythme==100)
{rythme=0;}
}


void init_monstre(monstre*munster){
munster->energie=3;
munster->etat=1;
}

void init_vaisseau(vaisseau*ship){

ship->x=64;
ship->y=32;
ship->vitesse=4;
ship->direction=0;
ship->energie=16;

}


int distance(int xv,int yv,int xe,int ye){
	int abscisse,ordonnee,distance;
	abscisse=pow((xe-xv),(2));
	ordonnee=pow((ye-yv),(2));
	distance=sqrt(abscisse+ordonnee);
	return distance;
}


int pluspetitedistance(int xe,int ye){
	int p1,p2,p3,p4,min,rep=0;
	p1=distance(vaisseau1.x,vaisseau1.y,xe+3,ye);
	p2=distance(vaisseau1.x,vaisseau1.y,xe-3,ye);
	p3=distance(vaisseau1.x,vaisseau1.y,xe,ye+3);
	p4=distance(vaisseau1.x,vaisseau1.y,xe,ye-3);
	min=p1;
	if(min>p2)
	{min=p2;}
	if(min>p3)
	{min=p3;}
	if(min>p4)
	{min=p4;}
	if(min==p1){rep=1;}
	if(min==p2){rep=2;}
	if(min==p3){rep=3;}
	if(min==p4){rep=4;}
	return rep;
}


/*cette fonctionne donne par ordre croissante la trajectoire la plus courte pour aller au vaisseau.*/
int cheminapp(targ *tableau,int xe,int ye){
	targ temp;
	int i,j,z;
	tableau[0].distance=distance(vaisseau1.x,vaisseau1.y,xe+3,ye);
	tableau[0].trajectoire=0;
	//printf("mur a droite %c\n",lev[(ye+16+32)/32][(xe+3+32)/32]);
	if((lev[(ye+3)/32][(xe+32+3)/32]=='9')||(lev[(ye+32-3)/32][(xe+32+3)/32]=='9'))
	{tableau[0].possibilite=0;}else{tableau[0].possibilite=1;}

	tableau[1].distance=distance(vaisseau1.x,vaisseau1.y,xe-3,ye);
	tableau[1].trajectoire=1;
	//printf("mur a gauche %c\n",lev[(ye+3)/32][(xe-3)/32]);
	if((lev[(ye+3)/32][(xe-3)/32]=='9')||(lev[(ye+32-3)/32][(xe-3)/32]=='9'))
	{tableau[1].possibilite=0;}else{tableau[1].possibilite=1;}

	tableau[2].distance=distance(vaisseau1.x,vaisseau1.y,xe,ye+3);
	tableau[2].trajectoire=2;
	//printf("mur en bas %c\n",lev[(ye+3)/32][(xe+16)/32]);
	if((lev[(ye+32+3)/32][(xe+3)/32]=='9')||(lev[(ye+32+3)/32][(xe+32-3)/32]=='9'))
	{tableau[2].possibilite=0;}else{tableau[2].possibilite=1;}

	tableau[3].distance=distance(vaisseau1.x,vaisseau1.y,xe,ye-3);
	tableau[3].trajectoire=3;
	//printf("mur en haut %c\n",lev[(ye-3)/32][(xe+16)/32]);
	if((lev[(ye-3)/32][(xe+3)/32]=='9')||(lev[(ye-3)/32][(xe+32-3)/32]=='9'))
	{tableau[3].possibilite=0;}else{tableau[3].possibilite=1;}

	for(j=0;j<4;j++)
	{
	z=4-j;
		for(i=0;i<z;i++)
		{
		if(tableau[i].distance>tableau[i+1].distance)
			{
				temp.distance=tableau[i+1].distance;
				temp.trajectoire=tableau[i+1].trajectoire;
				temp.possibilite=tableau[i+1].possibilite;
				tableau[i+1].distance=tableau[i].distance;
				tableau[i+1].trajectoire=tableau[i].trajectoire;
				tableau[i+1].possibilite=tableau[i].possibilite;
				tableau[i].distance=temp.distance;
				tableau[i].trajectoire=temp.trajectoire;
				tableau[i].possibilite=temp.possibilite;
			}
		}

	}
	i=0;
	while(tableau[i].possibilite==0){i++;}

	return tableau[i].trajectoire;
}


//cette fonctionne loigne le plus que possible la pastille nergie du vaisseau.
int cheminapp_pastille(targ *tabl0,int xe,int ye){
	targ temp;
	
	int i,j,z;
	tabl0[0].distance=distance(vaisseau1.x,vaisseau1.y,xe+3,ye);
	tabl0[0].trajectoire=0;
	//printf("mur a droite %c\n",lev[(ye+16+32)/32][(xe+3+32)/32]);
	if((lev[(ye+3)/32][(xe+32+3)/32]=='9')||(lev[(ye+32-3)/32][(xe+32+3)/32]=='9'))
	{tabl0[0].possibilite=0;}else{tabl0[0].possibilite=1;}

	tabl0[1].distance=distance(vaisseau1.x,vaisseau1.y,xe-3,ye);
	tabl0[1].trajectoire=1;
	//printf("mur a gauche %c\n",lev[(ye+3)/32][(xe-3)/32]);
	if((lev[(ye+3)/32][(xe-3)/32]=='9')||(lev[(ye+32-3)/32][(xe-3)/32]=='9'))
	{tabl0[1].possibilite=0;}else{tabl0[1].possibilite=1;}

	tabl0[2].distance=distance(vaisseau1.x,vaisseau1.y,xe,ye+3);
	tabl0[2].trajectoire=2;
	//printf("mur en bas %c\n",lev[(ye+3)/32][(xe+16)/32]);
	if((lev[(ye+32+3)/32][(xe+3)/32]=='9')||(lev[(ye+32+3)/32][(xe+32-3)/32]=='9'))
	{tabl0[2].possibilite=0;}else{tabl0[2].possibilite=1;}

	tabl0[3].distance=distance(vaisseau1.x,vaisseau1.y,xe,ye-3);
	tabl0[3].trajectoire=3;
	//printf("mur en haut %c\n",lev[(ye-3)/32][(xe+16)/32]);
	if((lev[(ye-3)/32][(xe+3)/32]=='9')||(lev[(ye-3)/32][(xe+32-3)/32]=='9'))
	{tabl0[3].possibilite=0;}else{tabl0[3].possibilite=1;}

	for(j=0;j<4;j++)
	{
	z=4-j;
	for(i=0;i<z;i++)
	{
	if(tabl0[i].distance>tabl0[i+1].distance)
	{
		temp.distance=tabl0[i+1].distance;
		temp.trajectoire=tabl0[i+1].trajectoire;
		temp.possibilite=tabl0[i+1].possibilite;
		tabl0[i+1].distance=tabl0[i].distance;
		tabl0[i+1].trajectoire=tabl0[i].trajectoire;
		tabl0[i+1].possibilite=tabl0[i].possibilite;
		tabl0[i].distance=temp.distance;
		tabl0[i].trajectoire=temp.trajectoire;
		tabl0[i].possibilite=temp.possibilite;
	}
	}

	}
	i=3;
	while(tabl0[i].possibilite==0)
	{i--;}


	/*printf("%d %d %d \n",POSS[0].trajectoire,POSS[0].distance,POSS[0].possibilite);
	printf("%d %d %d \n",POSS[1].trajectoire,POSS[1].distance,POSS[1].possibilite);
	printf("%d %d %d \n",POSS[2].trajectoire,POSS[2].distance,POSS[2].possibilite);
	printf("%d %d %d \n",POSS[3].trajectoire,POSS[3].distance,POSS[3].possibilite);*/
	return tabl0[i].trajectoire;
}


/*Fait apparaitre les fantomes aleatoirement*/
void apparition_monstre_type1(int*x,int*y){
	*y=1+(int) ((float)Hauteur_Jeu()*rand()/(RAND_MAX+1.0));
	*x=1+(int) ((float)Largeur_Jeu()*rand()/(RAND_MAX+1.0));
}

void tuer(monstre* munster){
if(munster->energie<=0){
	//monstre1.energie=0;
	//monstre1.x=-50;
	//monstre1.y=-50;
	munster->etat=0;
	joueur1.score+=1;
}else{
	munster->energie=munster->energie-1;
	//Preparer_Monstre(0,munster->type,0,munster->x,munster->y);
}
}


void PreparerNiveau(void){
int i=0,j=0,nextlarg=0,nexthaut=0;
nb_pastille=0;
for(i=0;i<=m;i++){
	for(j=0;j<n;j++){
		//printf("%c",lev[i][j]);
		switch(lev[i][j]){
			case '9' :
			Preparer_Mur(0,1,nextlarg,nexthaut);//un mur
			nextlarg+=Largeur_Monstre();
			break;

			case '5' :
			Preparer_Mur(0,0,nextlarg,nexthaut);// un mur type 2
			nextlarg+=Largeur_Monstre();
			break;

			case '0' :
			nextlarg+=Largeur_Monstre();//un espace
			break;

			case '1' ://une pastille
		Preparer_Pastille(0,0,nextlarg+Largeur_Pastille(),nexthaut+Largeur_Pastille());
			nextlarg+=Largeur_Monstre();
			nb_pastille++;
			break;

			case '2' ://une pastille type 2
			//printf("1");
		Preparer_Pastille(0,1,nextlarg+Largeur_Pastille(),nexthaut+Largeur_Pastille());
			nextlarg+=Largeur_Monstre();
			nb_pastille++;
			break;

			default :
			//lev[i][j]='9';
			//Preparer_Mur(0,1,nextlarg,nexthaut);
			nextlarg+=Largeur_Monstre();//un espace
			break;
		}

	}
	//printf("\n");
	nexthaut+=Hauteur_Monstre();
	nextlarg=0;//a la fin de la ligne on revien a 0
}

Afficher_Ecran(0);

}//FIN preparer niveau


void init_monstres_base(void){
	init_monstre(&monstre1);
	apparition_monstre_type1(&monstre1.x,&monstre1.y);
	monstre1.type=0;

	init_monstre(&monstre2);
	apparition_monstre_type1(&monstre2.x,&monstre2.y);
	monstre2.type=0;

	monstre3.x=32;
	monstre3.y=480;
	monstre3.type=2;
	init_monstre(&monstre3);
}

void AfficherNiveau(void){
FILE * niveau;

int caseniveau=0,i=0,j=0;
char fichier_a_lire[20];


printf("niveau %d\n",niveau_actuel);
switch(niveau_actuel){
	case 1:
	strcpy(fichier_a_lire,"./Lev/lev1.txt");
	joueur1.nb_vie=3;
	joueur1.score = 0;
	init_monstres_base();
	init_vaisseau(&vaisseau1);
	break;
	
	case 2:
	strcpy(fichier_a_lire,"./Lev/lev2.txt");
	init_monstres_base();
	init_pastille_energie();
	break;
	
	case 3:
	strcpy(fichier_a_lire,"./Lev/lev3.txt");
	init_monstres_base();
	break;
	
	case 4:
	strcpy(fichier_a_lire,"./Lev/lev4.txt");
	init_monstres_base();
	init_monstre(&monstre4);
	monstre4.x=128;
	monstre4.y=480;
	monstre4.type=1;
	
	init_pastille_energie();
	break;
	
	case 5:
	strcpy(fichier_a_lire,"./Lev/lev5.txt");
	init_monstres_base();
	init_monstre(&monstre4);
	monstre4.x=128;
	monstre4.y=480;
	monstre4.type=1;
	break;
	
	case 6:
	strcpy(fichier_a_lire,"./Lev/lev6.txt");
	/*monstre5=(monstre*)malloc(sizeof(monstre));
	apparition_monstre_type1(&monstre5->x,&monstre5->y);
	monstre5->type=0;*/
	init_monstre(&monstre4);
	monstre4.x=128;
	monstre4.y=480;
	monstre4.type=1;
	init_monstres_base();
	init_pastille_energie();
	break;
	case 7:
	strcpy(fichier_a_lire,"./Lev/lev7.txt");
	init_monstre(&monstre4);
	monstre4.x=128;
	monstre4.y=480;
	monstre4.type=1;
	init_monstres_base();
	break;
	
	case 8:
	strcpy(fichier_a_lire,"./Lev/lev8.txt");
	init_monstres_base();
	monstre6.x=296;
	monstre6.y=128;
	monstre6.type=0;
	init_monstre(&monstre6);
	apparition_monstre_type1(&monstre6.x,&monstre6.y);
	init_pastille_energie();
	break;
	
	case 9:
	strcpy(fichier_a_lire,"./Lev/lev9.txt");
	init_monstres_base();
	apparition_monstre_type1(&monstre6.x,&monstre6.y);
	init_pastille_energie();
	break;
	
	case 10:
	strcpy(fichier_a_lire,"./Lev/lev10.txt");
	init_monstres_base();
	//pastille_energie();
	break;
	default :
	strcpy(fichier_a_lire,"./Lev/lev1.txt");
	init_monstres_base();
	niveau_actuel=1;
	//printf("ENTRE DS DEFAULT %d\n",niveau_actuel);
	//pastille_energie();
	break;
}


if((niveau=fopen(fichier_a_lire,"r"))!=NULL){//si on arrive a ouvrir le fichier
	caseniveau=fgetc(niveau);
	while(caseniveau!=EOF){
		//printf("%c", caseniveau);
		//printf("[i %d]",i);
		//printf("[j %d]\n",j);
		lev[i][j]=caseniveau;
		caseniveau=fgetc(niveau);
		j++;
			if(caseniveau=='\n'){
				i++;
				j=0;
				caseniveau=fgetc(niveau);
			}
	}


fclose(niveau);
PreparerNiveau();

}else{
	printf("Fichier '%s' non trouve\n",fichier_a_lire);
}



}//fin de afficher niveau



/* La fonction associee au bouton Jouer */
void Jouer (void) {
	Lire_Niveau(&niveau_actuel);
	Preparer_Fond(0,0);
	AfficherNiveau();
	changement_niveau=0;
	compte_pause=0;
	Preparer_Vaisseau(0,0,vaisseau1.direction,vaisseau1.x,vaisseau1.y);
	Brancher_Timer(15);//execute le contenu de timer fini puis touches enfonces
	Afficher_Ecran (0);
}

/* La fonction associee au bouton Quitter */
void Quitter(void){
	Debrancher_Timer();
	Game_Over("A bientot");
}

void deplacement_vaisseau(int j1D,int j1G,int j1H,int j1B,int j1T){

if(j1G==1){

if((lev[(vaisseau1.y+3)/Hauteur_Vaisseau()][(vaisseau1.x-3)/Largeur_Vaisseau()]=='9')||(lev[(vaisseau1.y+Hauteur_Vaisseau()-3)/Hauteur_Vaisseau()][(vaisseau1.x-3)/Largeur_Vaisseau()]=='9')){

	}else{
	vaisseau1.x-=j1G*vaisseau1.vitesse;
	vaisseau1.direction=3;
	}
}


if(j1D==1){

if((lev[(vaisseau1.y+3)/Hauteur_Vaisseau()][(vaisseau1.x+Largeur_Vaisseau()+3)/Largeur_Vaisseau()]=='9')||(lev[(vaisseau1.y+Hauteur_Vaisseau()-3)/Hauteur_Vaisseau()][(vaisseau1.x+Largeur_Vaisseau()+3)/Largeur_Vaisseau()]=='9')){
	}else{
	vaisseau1.x+=j1D*vaisseau1.vitesse;
	vaisseau1.direction=1;
	}
}


if(j1B==1){
	if((lev[(vaisseau1.y+Hauteur_Vaisseau()+3)/Hauteur_Vaisseau()][(vaisseau1.x+3)/Largeur_Vaisseau()]=='9')||(lev[(vaisseau1.y+Hauteur_Vaisseau()+3)/Hauteur_Vaisseau()][(vaisseau1.x+Largeur_Vaisseau()-3)/Largeur_Vaisseau()]=='9')){
	}else{
	vaisseau1.y+=j1B*vaisseau1.vitesse;
	vaisseau1.direction=2;
	}
}

if(j1H==1){
	if((lev[(vaisseau1.y-3)/Hauteur_Vaisseau()][(vaisseau1.x+3)/Largeur_Vaisseau()]=='9')||(lev[(vaisseau1.y-3)/32][(vaisseau1.x+Largeur_Vaisseau()-3)/Largeur_Vaisseau()])=='9'){
	}else{
	vaisseau1.y-=j1H*vaisseau1.vitesse;
	vaisseau1.direction=0;
	}
}

}

void deplacer_tir(void){

//droite
	if(tir1.direction==1){
	//printf("TIR \n ");
		tir1.x+=8;
		Preparer_Tir_Vaisseau(0,0,tir1.x,tir1.y);
if((lev[(tir1.y)/Largeur_Case][(tir1.x+Largeur_Pastille())/Largeur_Case]=='9')||(lev[(tir1.y)/Largeur_Case][(tir1.x+Largeur_Pastille())/Largeur_Case]=='9')){tir1.etat=0;}
	}
	//haut
	if(tir1.direction==0){
		tir1.y-=8;
		Preparer_Tir_Vaisseau(0,0,tir1.x,tir1.y);
		//if(tir1.y<=0){tir1.etat=0;}
if((lev[(tir1.y)/Largeur_Case][(tir1.x)/Largeur_Case]=='9')||(lev[(tir1.y)/Largeur_Case][(tir1.x)/Largeur_Case])=='9'){tir1.etat=0;}
	}
	//bas
	if(tir1.direction==2){
		tir1.y+=8;
		Preparer_Tir_Vaisseau(0,0,tir1.x,tir1.y);
if((lev[(tir1.y+Hauteur_Pastille())/Largeur_Case][(tir1.x)/Largeur_Case]=='9')||(lev[(tir1.y+3+Hauteur_Pastille())/Largeur_Case][(tir1.x)/Largeur_Case]=='9')){
			tir1.etat=0;
		}
	}
	//gauche
	if(tir1.direction==3){
		tir1.x-=8;
		Preparer_Tir_Vaisseau(0,0,tir1.x,tir1.y);
if((lev[(tir1.y)/Largeur_Case][(tir1.x)/Largeur_Case]=='9')||(lev[(tir1.y)/Largeur_Case][(tir1.x)/Largeur_Case]=='9')){tir1.etat=0;}
}

}

//test de collision des tirs sur les monstres
void coll_monstre(monstre* munster){
if((tir1.x>munster->x)&&(tir1.x<munster->x+Largeur_Monstre())){
	if((tir1.y>munster->y)&&(tir1.y<munster->y+Largeur_Monstre())){
		tir1.etat=0;
		tir1.x=-50;
		tir1.y=-50;
		tuer(munster);
		}
}

}

// test de collision des monstres sur les vaisseaux
void coll_vaisseau(monstre* munster){

if((munster->x>=vaisseau1.x)&&(munster->x<=vaisseau1.x+32)){
	if((munster->y>=vaisseau1.y)&&(munster->y<=vaisseau1.y+32)){
		//tuer(munster);
		vaisseau1.energie--;
		if(vaisseau1.energie<=0){
			//vaisseau1.etat=0;
			joueur1.nb_vie--;
			init_vaisseau(&vaisseau1);
				if(joueur1.nb_vie==0){
				Debrancher_Timer();
				Game_Over("Game Over");
				joueur1.score=0;
				Fin_Jeu();
				}
		}
		//printf("vaisseau 1 . energie %d\n" ,vaisseau1.energie);
	}
}

}



void recup_pastille(void){
int x_tableau,y_tableau;

x_tableau=(vaisseau1.x+Largeur_Pastille())/Largeur_Vaisseau();
y_tableau=(vaisseau1.y+Largeur_Pastille())/Hauteur_Vaisseau();


//if((lev[y_tableau][x_tableau]=='1')||(lev[y_tableau][x_tableau])=='2'){
if(lev[y_tableau][x_tableau]=='1'){
		nb_pastille--;
		if(nb_pastille==0){
			changement_niveau=1;
		}
			lev[y_tableau][x_tableau]='0';
		joueur1.score++;
		}

}



void deplacement_monstre_type1(monstre*munster){

munster->choix=pluspetitedistance(munster->x,munster->y);


if(((vaisseau1.y>munster->y)&&(vaisseau1.direction!=0))
	||
	((vaisseau1.y<munster->y)&&(vaisseau1.direction!=2)))
	
	{
	if(munster->choix==1)
	{
	munster->x=munster->x+1;
	munster->direction=0;}
	if(munster->choix==2)
	{
	munster->x=munster->x-1;
	munster->direction=0;
	}
	if(munster->choix==3)
	{
	munster->y=munster->y+1;
	munster->direction=0;
	}
	if(munster->choix==4)
	{
	munster->y=munster->y-1;
	munster->direction=0;
	}
	
	}
	else
	{
	munster->temporaire_x=munster->x;
	munster->temporaire_y=munster->y;
	if((rythme%4)==0){
	munster->x=-100;
	munster->y=-100;}
	Preparer_Monstre(0,0,0,munster->x,munster->y);
	munster->x=munster->temporaire_x;
	munster->y=munster->temporaire_y;
	}
}

void deplacement_monstre_type2(monstre*munster){

	if(((munster->x%32)==0)&&((munster->y)%32)==0){
		munster->choix=cheminapp(munster->POSS,munster->x,munster->y);
		//printf("choix = %d\n",monstre3.choix);
	}
	if(munster->choix==0){
	//munster->x=munster->x+1;
	munster->x=munster->x+(niveau_actuel+2)/3;
	munster->direction=1;
	}
	if(munster->choix==1){
	//munster->x=munster->x-1;
	munster->x=munster->x-(niveau_actuel+2)/3;
	munster->direction=3;
	}
	if(munster->choix==2){
	//munster->y=munster->y+1;
	munster->y=munster->y+(niveau_actuel+2)/3;
	munster->direction=2;
	}
	if(munster->choix==3){
	//munster->y=munster->y-1;
	munster->y=munster->y-(niveau_actuel+2)/3;
	munster->direction=0;
	}

}


void deplacement_pastille_energie(void){
if(((pastille1.x%32)==0)&&((pastille1.y%32)==0)){
pastille1.choix=cheminapp_pastille(pastille1.POSS,pastille1.x,pastille1.y);
//printf("choix = %d\n",pastille1.choix);
}

if(pastille1.choix==0)
{pastille1.x=pastille1.x+2;}
if(pastille1.choix==1)
{pastille1.x=pastille1.x-2;}
if(pastille1.choix==2)
{pastille1.y=pastille1.y+2;}
if(pastille1.choix==3)
{pastille1.y=pastille1.y-2;}

if((pow((vaisseau1.x-pastille1.x),2)<49)&&(pow((vaisseau1.y-pastille1.y),2)<49))
{
pastille1.x=-1000;
pastille1.y=-1000;
vaisseau1.energie=16;
joueur1.score+=5;
}
}


void Touches_Enfoncees(char touches[NB_TOUCHES]){
int j1D=0,j1G=0,j1H=0,j1B=0,j1T=0;

Preparer_Fond(0,0);
//printf("changer niveau TOUCHES ENFONCEES= %d\n",changement_niveau);
if (changement_niveau==1)
  {

    // Changer le papier peint pour indiquer changement niveau;
    Preparer_Fond(0,1);
    Afficher_Ecran(0);
    Afficher_Score(joueur1.score,0);
    // Laisser ce papier peint pendant x secondes
      compte_pause++;
      //AfficherNiveau();
      if (compte_pause >= 100){
    	//Charger le nouveau niveau

	// recommencer normalement

	Preparer_Fond(0,0);
    	changement_niveau=0;
	compte_pause=0;
	niveau_actuel++;
	Afficher_Niveau(niveau_actuel);

	/*On fait les fantomes prendre une posistion aleatoire ds le jeu*/
	apparition_monstre_type1(&monstre1.x,&monstre1.y);
	apparition_monstre_type1(&monstre2.x,&monstre2.y);
	//if(niveau_actuel>=8){
	//apparition_monstre_type1(&monstre6.x,&monstre6.y);
	//}

	/*On reinitialise les autres monstres*/
	init_monstre(&monstre3);
	if(niveau_actuel>=4){
	init_monstre(&monstre4);
	}

	AfficherNiveau();
	}
	
  }else{
  
if(touches[0]==1){
j1D=1;
}
if(touches[1]==1){
j1G=1;
}
if(touches[2]==1){
j1H=1;
}
if(touches[3]==1){
j1B=1;
}
if(touches[4]==1){
j1T=1;
}

deplacement_vaisseau(j1D,j1G,j1H,j1B,j1T);
recup_pastille();

//Tir avec directions
if(tir1.etat==0){
if(j1T==1){
			tir1.x=vaisseau1.x+(Largeur_Vaisseau()/2)-(Largeur_Pastille()/2);
			tir1.y=vaisseau1.y+(Hauteur_Vaisseau()/2)-(Hauteur_Pastille()/2);
			Preparer_Tir_Vaisseau(0,0,tir1.x,tir1.y);
			tir1.direction=vaisseau1.direction;
			tir1.etat=1;
}
}else{
	deplacer_tir();
}

deplacement_pastille_energie();
Preparer_Pastille(0,1,pastille1.x+10,pastille1.y+10);

//printf(" x = %d    y = %d\n", pastille1.x,pastille1.y);
//printf(" x monstre1:%d   x monstre2:%d\n", monstre1.x,monstre2.x);
Afficher_Score(joueur1.score,0);
Afficher_Ecran(0);

//trajchoisie(monstre1.x,monstre1.y);

//Preparer_Fond(0,1);

PreparerNiveau();
Preparer_Vies(0,0,joueur1.nb_vie);
Preparer_Energie(0,0,vaisseau1.energie);


/*Fantome*/
if(monstre1.etat==1){
deplacement_monstre_type1(&monstre1);
coll_vaisseau(&monstre1);
if(((vaisseau1.y>=monstre1.y)&&(vaisseau1.direction!=0))
	||
	((vaisseau1.y<=monstre1.y)&&(vaisseau1.direction!=2)))
	
	{Preparer_Monstre(0,monstre1.type,monstre1.direction,monstre1.x,monstre1.y);}
}

/*Fantome*/
if(monstre2.etat==1){
if((pow((monstre1.x-monstre2.x),2)>81) &&(pow((monstre1.y-monstre2.y),2)>81)){
//printf(" X = %d    Y = %d\n", monstre2.x,monstre2.y);
deplacement_monstre_type1(&monstre2);
}
coll_vaisseau(&monstre2);
if(((vaisseau1.y>monstre2.y)&&(vaisseau1.direction!=0))
	||
	((vaisseau1.y<monstre2.y)&&(vaisseau1.direction!=2)))
	
	{Preparer_Monstre(0,monstre2.type,monstre1.direction,monstre2.x,monstre2.y);}
}

/*Fantome*/
if(monstre6.etat==1){
deplacement_monstre_type1(&monstre6);
coll_vaisseau(&monstre1);
Preparer_Monstre(0,monstre6.type,monstre6.direction,monstre6.x,monstre6.y);
}
/*Zombie*/
if(monstre3.etat==1){
deplacement_monstre_type2(&monstre3);
coll_monstre(&monstre3);
coll_vaisseau(&monstre3);
Preparer_Monstre(0,monstre3.type,monstre3.direction,monstre3.x,monstre3.y);
}
/*Babidi */
if(monstre4.etat==1){
deplacement_monstre_type2(&monstre4);
coll_monstre(&monstre4);
coll_vaisseau(&monstre4);
Preparer_Monstre(0,monstre4.type,monstre4.direction,monstre4.x,monstre4.y);
}

/*
printf( "TETS");
if(monstre5->etat==1){
deplacement_monstre_type1(monstre5);
//coll_monstre(&monstre1);
coll_vaisseau(monstre5);
Preparer_Monstre(0,monstre5->type,monstre5->direction,monstre5->x,monstre5->y);
}
*/

Preparer_Vaisseau(0,0,vaisseau1.direction,vaisseau1.x,vaisseau1.y);
Afficher_Ecran(0);
}

}// FIN touche enfoncees


/************** Les deux fonctions a appeler dans le main ******/
void Init_Jeu (int nb, int ne, int invulnerable) {
 // time_t t_loc;
  //struct tm *tmp;

  fprintf(stdout,"Hi!\n");
 // time(&t_loc);
  //tmp= localtime(&t_loc);
 // srand(getpid()*(tmp->tm_sec));
}

void Fin_Jeu (void) {
  fprintf(stdout,"Bye!\n");
}

