#ifndef _INTERFACE_GTK_H
#define _INTERFACE_GTK_H

/*------------------------------------
 *  PARAMETRES INTERFACE GRAPHIQUE
 *-----------------------------------*/

/* Taille des boutons */
#define LARG_BOUTON	70
#define HAUT_BOUTON	30

#define GAUCHE        0
#define DROITE        1
#define HAUT          2
#define BAS	      3

#define TAILLE_MSG   64

/*------------------------------------
 *     PARAMETRES DE JEU
 *----------------------------------*/
/* Nbre de colonnes de jeu */
#define LARG_JEU	384
/* Nbre de lignes de jeu */
#define HAUT_JEU	576

#define NB_VAISSEAU 2
#define NB_MONSTRE 3
#define NB_MUR 2
#define NB_TIRS_VAISSEAU 2
#define NB_TIRS_ENNEMIS 2
#define NB_PASTILLES 2

typedef struct unSprite
{
   GdkPixmap *pixmap;
   GdkBitmap *mask;
   gint width;
   gint height;
} Sprite;


enum {JOUEUR1, JOUEUR2} JOUEUR;
 
#endif /* _INTERFACE_GTK_H */
