#ifndef _INTERFACE_EXTERN_H
#define _INTERFACE_EXTERN_H
#define Largeur_Case 32

void Init_Jeu(int nb_players, int nb_ecrans, int invulnerable);
void Interface_Jeu(int nb_players, int nb_ecrans);
void Fin_Jeu(void);

void Changer_Nom_Joueur (char *nom, int num_joueur);

void Afficher_Ecran     (int num_ecran);
void Afficher_Score     (int score, int num_joueur);
void Afficher_Killed    (int killed, int num_joueur);

void Game_Over(char *text);
void Brancher_Timer(int millisecondes);
void Debrancher_Timer(void);

void Lire_Niveau (int *niveau );
void Afficher_Niveau(int niveau);

void Preparer_Vaisseau(int num_ecran, int num_vaisseau, int dir, int x, int y);
void Preparer_Monstre(int num_ecran, int num_monstre, int dir, int x, int y);
void Preparer_Fond(int num_ecran,int num_fond);
void Preparer_Mur(int num_ecran, int num_mur, int x, int y);
void Preparer_Tir_Vaisseau(int num_ecran, int num_tir, int x, int y);
void Preparer_Tir_Ennemi(int num_ecran, int num_tir, int x, int y);
void Preparer_Pastille(int num_ecran, int num_pastille, int x, int y);

void Preparer_Energie(int num_ecran, int num_joueur, int energie);
void Preparer_Vies(int num_ecran, int num_joueur, int vies);

int Largeur_Jeu(void);
int Hauteur_Jeu(void);

int Largeur_Vaisseau(void);
int Hauteur_Vaisseau(void);

int Largeur_Monstre(void);
int Hauteur_Monstre(void);

int Largeur_Boss(int num_boss);
int Hauteur_Boss(int num_boss);

int Largeur_Tir_Vaisseau(void);
int Hauteur_Tir_Vaisseau(void);

int Largeur_Tir_Ennemi(void);
int Hauteur_Tir_Ennemi(void);

int Largeur_Pastille(void);
int Hauteur_Pastille(void);

#endif /* _INTERFACE_EXTERN_H */
